Attribute VB_Name = "gtradermod"
Public pbgl As New clspbgl

Public Type plr
    sname As String
    team As Integer
    followmode As Integer
    x As Single
    y As Single
    screenx As Single
    screeny As Single
    centerx As Single
    centery As Single
    xspeed As Single
    yspeed As Single
    health As Single
    maxhealth As Single
    shields As Single
    maxshields As Single
    weapon As Integer
    accel As Single
    energy As Single
    maxenergy As Single
    egrate As Single
    fuel As Single
    maxfuel As Single
    'items etc
    credits As Integer
    water As Integer
    food As Integer
    skins As Integer
    weapons As Integer
    drugs As Integer
    metal As Integer
    robots As Integer
    computers As Integer
    darkfeign As Integer
    'cargo bays
    bays As Integer
    'image etc
    species As Integer
    'width height
    width As Integer
    height As Integer
    'enabled?
    benabled As Boolean
    'radius - how far around a center can be to be detected as collision
    radius As Single
    'target, which player out of array is target
    target As Integer
    closeststation As Integer
    tradingdist As Single
    apdestx As Single
    apdesty As Single
    ap As Boolean
End Type

Public Type projectil
    team As Integer
    follows As Boolean
    followmode As Integer
    damages As Boolean
    x As Single
    y As Single
    screenx As Single
    screeny As Single
    centerx As Single
    centery As Single
    xspeed As Single
    yspeed As Single
    accel As Single
    damage As Single
    lifelength As Integer
    spawnssmoke As Boolean
    spawnrate As Integer
    tickcount As Integer
    spawntick As Integer
    'width height
    width As Integer
    height As Integer
    'enabled?
    benabled As Boolean
    'images
    species As Integer
    radius As Single
End Type

Public Type pickp
    x As Single
    y As Single
    screenx As Single
    screeny As Single
    centerx As Single
    centery As Single
    xspeed As Single
    yspeed As Single
    credits As Integer
    water As Integer
    food As Integer
    skins As Integer
    weapons As Integer
    drugs As Integer
    metal As Integer
    robots As Integer
    computers As Integer
    darkfeign As Integer
    'images
    species As Integer
    'width height
    width As Integer
    height As Integer
    'enabled?
    benabled As Boolean
    radius As Single
End Type

Public Type statn
    sname As String
    x As Single
    y As Single
    screenx As Single
    screeny As Single
    centerx As Single
    centery As Single
    xspeed As Single
    yspeed As Single
    'prices
    waterprice As Integer
    foodprice As Integer
    skinsprice As Integer
    weaponsprice As Integer
    drugsprice As Integer
    metalprice As Integer
    robotsprice As Integer
    computersprice As Integer
    darkfeignprice As Integer
    'how many does the station have?
    water As Integer
    food As Integer
    skins As Integer
    weapons As Integer
    drugs As Integer
    metal As Integer
    robots As Integer
    computers As Integer
    darkfeign As Integer
    'image etc
    species As Integer
    'tick
    pricechangetick As Integer
    'width height
    width As Integer
    height As Integer
    'enabled?
    benabled As Boolean
    radius As Single
End Type

Public Type engset
    colltick As Integer
    phystick As Integer
    rendertick As Integer
    collacc As Integer
    physacc As Integer
    renderacc As Integer
    statstick As Integer
End Type
    
Public player(999) As plr

Public projectile(999) As projectil

Public pickup(999) As pickp

Public station(999) As statn

Public enginesettings As engset



Public Sub game_init()
'display "loading" on screen while this stuff is done
main.Show
pbgl.glsetcolor main.picgame, vbWhite
pbgl.gltext main.picgame, main.picgame.width / 2 - 40, main.picgame.height / 2 - 20, "Loading..."
main.picgame.Refresh

camera.camheight = 480
camera.camwidth = 640

enginesettings.collacc = 1
enginesettings.physacc = 1
enginesettings.renderacc = 1
enginesettings.colltick = 0
enginesettings.phystick = 0
enginesettings.rendertick = 0
enginesettings.statstick = 0

'this gets run at the start of the program, to set up various game parameters
pbgl.glloadpicture main.p1, App.Path & "\images\ship1.bmp"
pbgl.glloadpicture main.p2, App.Path & "\images\ship2.bmp"
pbgl.glloadpicture main.p3, App.Path & "\images\ship3.bmp"
pbgl.glloadpicture main.p4, App.Path & "\images\ship4.bmp"
pbgl.glloadpicture main.p5, App.Path & "\images\ship5.bmp"
pbgl.glloadpicture main.p6, App.Path & "\images\ship6.bmp"
pbgl.glloadpicture main.p7, App.Path & "\images\ship7.bmp"
pbgl.glloadpicture main.p8, App.Path & "\images\ship8.bmp"
pbgl.glloadpicture main.p9, App.Path & "\images\ship9.bmp"
pbgl.glloadpicture main.p10, App.Path & "\images\ship10.bmp"
pbgl.glloadpicture main.p11, App.Path & "\images\ship11.bmp"
pbgl.glloadpicture main.p12, App.Path & "\images\shipmask.bmp"
pbgl.glloadpicture main.p13, App.Path & "\images\pickup.bmp"
pbgl.glloadpicture main.p14, App.Path & "\images\pickupmask.bmp"
pbgl.glloadpicture main.p15, App.Path & "\images\station.bmp"
pbgl.glloadpicture main.p16, App.Path & "\images\stationmask.bmp"
pbgl.glloadpicture main.p17, App.Path & "\images\smoke.bmp"
pbgl.glloadpicture main.p18, App.Path & "\images\fire.bmp"
pbgl.glloadpicture main.p19, App.Path & "\images\smokefiremask.bmp"
pbgl.glloadpicture main.p20, App.Path & "\images\bullet.bmp"
pbgl.glloadpicture main.p21, App.Path & "\images\bulletmask.bmp"

'setting up stations and such

'load player save game info

'this just goes here for now to set up main player
'till i get the rest done
player(0).accel = 0.1
player(0).health = 100
player(0).maxhealth = 100
player(0).maxshields = 200
player(0).shields = 200
player(0).maxenergy = 500
player(0).energy = 500
player(0).x = 0
player(0).y = 0
player(0).benabled = 1
player(0).sname = "Player"
player(0).fuel = 1000
player(0).maxfuel = 1000
player(0).species = 1
player(0).width = 32
player(0).height = 32

'set up player/pickup/station etc. radiuses
Dim x
For x = 0 To 999
    'player
    player(i).radius = 16
    'station
    station(i).radius = 64
    'pickup
    pickup(i).radius = 8
Next x


'make a bunch of players for test
For r = 0 To 333
spawn_player rand_num(-2048, 2048), rand_num(-2048, 2048), "Pirate", 1, 1, 50, 50, 50, 50, 500, 500, 0.1, 1, rand_num(2, 9), 5, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
Next r

For k = 0 To 333
spawn_player rand_num(-2048, 2048), rand_num(-2048, 2048), "Trader", 1, 1, 50, 50, 50, 50, 500, 500, 0.1, 1, 10, 5, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
Next k

For z = 0 To 333
spawn_player rand_num(-2048, 2048), rand_num(-2048, 2048), "Police", 1, 1, 50, 50, 50, 50, 500, 500, 0.1, 1, 11, 5, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
Next z

For p = 0 To 199
spawn_projectile rand_num(-2048, 2048), rand_num(-2048, 2048), 1, 16, 16, rand_num(-20, 20), rand_num(-20, 20), False, 0, 0.15, True, 4, 64, True, 1, 1, 8
Next p

For p = 0 To 199
spawn_projectile rand_num(-2048, 2048), rand_num(-2048, 2048), 1, 16, 16, rand_num(-20, 20), rand_num(-20, 20), False, 0, 0.15, True, 4, 64, True, 1, 2, 8
Next p

For p = 0 To 199
spawn_projectile rand_num(-2048, 2048), rand_num(-2048, 2048), 1, 16, 16, rand_num(-20, 20), rand_num(-20, 20), False, 0, 0.15, True, 4, 64, True, 1, 3, 8
Next p

For p = 0 To 199
spawn_projectile rand_num(-2048, 2048), rand_num(-2048, 2048), 1, 16, 16, rand_num(-20, 20), rand_num(-20, 20), False, 0, 0.15, True, 4, 64, True, 1, 4, 4
Next p

For p = 0 To 199
spawn_projectile rand_num(-2048, 2048), rand_num(-2048, 2048), 1, 16, 16, rand_num(-20, 20), rand_num(-20, 20), False, 0, 0.15, True, 4, 64, True, 1, 5, 1
Next p

For p = 0 To 999
spawn_pickup rand_num(-2048, 2048), rand_num(-2048, 2048), rand_num(-20, 20), rand_num(-20, 20), 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
Next p

For s = 0 To 999
spawn_station rand_num(-2048, 2048), rand_num(-2048, 2048), rand_num(-20, 20), rand_num(-20, 20), "Station", 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
Next s

End Sub

Public Sub keyboard_actions()
'in here goes every keyboard related even
'ex: a to acquire target, space to shoot etc.
If keyboard.downdown = True Then
    move_player_down (0)
End If

If keyboard.updown = True Then
    move_player_up (0)
End If

If keyboard.rightdown = True Then
    move_player_right (0)
End If

If keyboard.leftdown = True Then
    move_player_left (0)
End If

If keyboard.adown = True Then
    maxframerate = maxframerate + 1
End If

If keyboard.zdown = True Then
    maxframerate = maxframerate - 1
End If

End Sub

Public Sub move_player_down(plr As Integer)
If player(plr).fuel > 0 Then
    player(plr).fuel = player(plr).fuel - player(plr).accel
    player(plr).yspeed = player(plr).yspeed + player(plr).accel
End If
End Sub

Public Sub move_player_up(plr As Integer)
If player(plr).fuel > 0 Then
    player(plr).fuel = player(plr).fuel - player(plr).accel
    player(plr).yspeed = player(plr).yspeed - player(plr).accel
End If
End Sub

Public Sub move_player_right(plr As Integer)
If player(plr).fuel > 0 Then
    player(plr).fuel = player(plr).fuel - player(plr).accel
    player(plr).xspeed = player(plr).xspeed + player(plr).accel
End If
End Sub

Public Sub move_player_left(plr As Integer)
If player(plr).fuel > 0 Then
    player(plr).fuel = player(plr).fuel - player(plr).accel
    player(plr).xspeed = player(plr).xspeed - player(plr).accel
End If
End Sub

Public Sub test_ai(plr As Integer)
'this is the temporary test AI, all bots follow player

If player(plr).x < player(0).x Then
    move_player_right (plr)
End If

If player(plr).x > player(0).x Then
    move_player_left (plr)
End If

If player(plr).y < player(0).y Then
    move_player_down (plr)
End If

If player(plr).y > player(0).y Then
    move_player_up (plr)
End If

End Sub


Public Sub damage_player_health(plr As Integer, damage As Single)
player(plr).health = player(plr).health - damage
End Sub

Public Sub damage_player_shield(plr As Integer, damage As Single)
player(plr).shields = player(plr).shields - damage
End Sub

Public Sub render_player_stats()
pbgl.glsetcolor main.picgame, vbRed
pbgl.gltext main.picgame, 1, 1, "Health = " & player(0).health & "/" & player(0).maxhealth
pbgl.glsetcolor main.picgame, vbYellow
pbgl.gltext main.picgame, 1, 20, "Shields = " & player(0).shields & "/" & player(0).maxshields
pbgl.glsetcolor main.picgame, vbGreen
pbgl.gltext main.picgame, 1, 40, "Energy = " & player(0).energy & "/" & player(0).maxenergy
pbgl.glsetcolor main.picgame, vbWhite
pbgl.gltext main.picgame, 1, 60, "Fuel = " & player(0).fuel & "/" & player(0).maxfuel
End Sub


Public Sub player_get_pickup(plr As Integer, pkp As Integer)
player(plr).credits = player(plr).credits + pickup(pkp).credits
player(plr).water = player(plr).water + pickup(pkp).water
player(plr).food = player(plr).food + pickup(pkp).food
player(plr).skins = player(plr).skins + pickup(pkp).skins
player(plr).weapons = player(plr).weapons + pickup(pkp).weapons
player(plr).drugs = player(plr).drugs + pickup(pkp).drugs
player(plr).metal = player(plr).metal + pickup(pkp).metal
player(plr).robots = player(plr).robots + pickup(pkp).robots
player(plr).robots = player(plr).robots + pickup(pkp).robots
player(plr).computers = player(plr).computers + pickup(pkp).computers
player(plr).darkfeign = player(plr).darkfeign + pickup(pkp).darkfeign
End Sub

Public Sub check_for_collisions()
'check for collissions between player/projectile and player/pickup
    Dim i As Integer
    Dim r As Integer
    Dim tempdist1 As Single
    
    For i = 0 To 999
        If player(i).benabled Then
            For r = 0 To 999
                'check player/projectiles
                If projectile(r).benabled Then
                    tempdist1 = distance(player(i).x, player(i).y, projectile(r).x, projectile(r).y) - (player(i).radius + projectile(r).radius)
                        If tempdist1 <= 0 Then
                            collision_player_projectile i, r
                        End If
                End If
                'check player/pickups
                If pickup(r).benabled Then
                    tempdist1 = distance(player(i).x, player(i).y, pickup(r).x, pickup(r).y) - (player(i).radius + pickup(r).radius)
                        If tempdist1 <= 0 Then
                            collision_player_pickup i, r
                        End If
                End If
            Next r
        End If
    Next i
End Sub

Public Sub collision_player_projectile(plr As Integer, proj As Integer)

End Sub

Public Sub collision_player_pickup(plr As Integer, proj As Integer)

End Sub

'#########################################################
'all subs below this
'are for spawning
'various game objects
'#########################################################
    
Public Sub spawn_player(xpos As Single, ypos As Single, namme As String, team As Integer, weapon As Integer, maxhealth As Single, maxshield As Single, egrate As Single, maxenergy As Single, fuel As Single, maxfuel As Single, accelerationrate As Single, followmode As Integer, species As Integer, bays As Integer, credits As Integer, water As Integer, food As Integer, skins As Integer, weapons As Integer, drugs As Integer, metal As Integer, robots As Integer, computers As Integer, darkfeign As Integer)
'for spawning players!
Dim i As Integer
For i = 0 To 999
    If player(i).benabled = False Then
        player(i).team = team
        player(i).x = xpos
        player(i).y = ypos
        player(i).sname = namme
        player(i).weapon = weapon
        player(i).maxhealth = maxhealth
        player(i).health = maxhealth
        player(i).maxshields = maxshields
        player(i).shields = maxshields
        player(i).maxenergy = maxenergy
        player(i).egrate = egrate
        player(i).bays = bays
        player(i).followmode = followmode
        'yes, this player is now enabled
        player(i).benabled = True
        '^^
        player(i).accel = accelerationrate
        player(i).species = species
        player(i).height = 32
        player(i).width = 32
        player(i).egrate = egrate
        
        player(i).fuel = fuel
        player(i).maxfuel = maxfuel
        
        'setting what the player carries
        player(i).credits = credits
        player(i).water = water
        player(i).weapons = weapons
        player(i).robots = robots
        player(i).food = food
        player(i).metal = metal
        player(i).darkfeign = darkfeign
        player(i).computers = computers
        player(i).drugs = drugs
        player(i).skins = skins
        Exit Sub
    End If
Next i
End Sub

Public Sub spawn_projectile(xpos As Single, ypos As Single, team As Integer, width As Integer, height As Integer, xspeed As Integer, yspeed As Integer, damages As Boolean, damage As Integer, accel As Single, spawnssmoke As Boolean, spawnrate As Integer, lifelength As Integer, follows As Boolean, followmode As Integer, species As Integer, radius As Single)
'for spawning players!
Dim i As Integer
For i = 0 To 999
    If projectile(i).benabled = False Then
        projectile(i).team = team
        projectile(i).x = xpos
        projectile(i).y = ypos
        projectile(i).accel = accel
        projectile(i).followmode = followmode
        projectile(i).follows = follows
        projectile(i).spawnssmoke = spawnssmoke
        projectile(i).lifelength = lifelength
        projectile(i).spawnrate = spawnrate
        projectile(i).damages = damages
        projectile(i).damage = damage
        projectile(i).xspeed = xspeed
        projectile(i).yspeed = yspeed
        'yes, this projectile is now enabled
        projectile(i).benabled = True
        '^^
        projectile(i).accel = accelerationrate
        projectile(i).species = species
        projectile(i).height = height
        projectile(i).width = width
        projectile(i).radius = radius
        Exit Sub
    End If
Next i
End Sub

Public Sub spawn_pickup(xpos As Single, ypos As Single, xspeed As Integer, yspeed As Integer, credits As Integer, water As Integer, food As Integer, skins As Integer, weapons As Integer, drugs As Integer, metal As Integer, robots As Integer, computers As Integer, darkfeign As Integer)
Dim i As Integer
For i = 0 To 999
    If pickup(i).benabled = False Then
        pickup(i).x = xpos
        pickup(i).y = ypos
        pickup(i).xspeed = xspeed
        pickup(i).yspeed = yspeed
        'yes, this pickup is now enabled
        pickup(i).benabled = True
        '^^
        pickup(i).height = 16
        pickup(i).width = 16
        pickup(i).credits = credits
        pickup(i).water = water
        pickup(i).weapons = weapons
        pickup(i).robots = robots
        pickup(i).food = food
        pickup(i).metal = metal
        pickup(i).darkfeign = darkfeign
        pickup(i).computers = computers
        pickup(i).drugs = drugs
        pickup(i).skins = skins
        Exit Sub
    End If
Next i
End Sub


Public Sub spawn_station(xpos As Single, ypos As Single, xspeed As Single, yspeed As Single, namme As String, water As Integer, food As Integer, skins As Integer, weapons As Integer, drugs As Integer, metal As Integer, robots As Integer, computers As Integer, darkfeign As Integer, waterprice As Integer, foodprice As Integer, skinsprice As Integer, weaponsprice As Integer, drugsprice As Integer, metalprice As Integer, robotsprice As Integer, computersprice As Integer, darkfeignprice As Integer)
Dim i As Integer
For i = 0 To 999
    If station(i).benabled = False Then
        station(i).x = xpos
        station(i).y = ypos
        station(i).xspeed = xspeed
        station(i).yspeed = yspeed
        'yes, this pickup is now enabled
        station(i).benabled = True
        '^^
        station(i).height = 128
        station(i).width = 128
        station(i).water = water
        station(i).weapons = weapons
        station(i).robots = robots
        station(i).food = food
        station(i).metal = metal
        station(i).darkfeign = darkfeign
        station(i).computers = computers
        station(i).drugs = drugs
        station(i).skins = skins
        station(i).waterprice = waterprice
        station(i).weaponsprice = weaponsprice
        station(i).robotsprice = robotsprice
        station(i).foodprice = foodprice
        station(i).metalprice = metalprice
        station(i).darkfeignprice = darkfeignprice
        station(i).computersprice = computersprice
        station(i).drugsprice = drugsprice
        station(i).skinsprice = skinsprice
        station(i).sname = namme
        Exit Sub
    End If
Next i
End Sub

