Attribute VB_Name = "gtradermod"

Public pbgl As New clspbgl

Public Type weapn
    name As String
    edrain As Long
    damage As Long
    follows As Boolean
    followmode As Long
    spawnssmoke As Boolean
    spawnrate As Long
    accel As Single
    lifelength As Long
    details As String
End Type

Public Type plr
    sname As String
    team As Long
    followmode As Long
    x As Single
    y As Single
    screenx As Single
    centerx As Single
    screeny As Single
    xspeed As Single
    centery As Single
    yspeed As Single
    health As Long
    maxhealth As Long
    shields As Long
    maxshields As Long
    accel As Single
    energy As Single
    maxenergy As Single
    egrate As Single
    fuel As Single
    maxfuel As Single
    level As Long
    exp As Long
    maxexp As Long
    'items etc
    credits As Long
    food As Long
    metals As Long
    weapons As Long
    gems As Long
    'cargo bays
    bays As Long
    'image etc
    species As Long
    'width height
    width As Long
    height As Long
    'enabled?
    benabled As Boolean
    'radius - how far around a center can be to be detected as collision
    radius As Single
    'target, which player out of array is target
    target As Long
    closeststation As Long
    tradingdist As Single
    apdestx As Single
    apdesty As Single
    ap As Boolean
    tickcount As Long
    acquiretick As Long
    weapon As weapn
    firepressed As Boolean
End Type

Public Type projectil
    team As Long
    follows As Boolean
    followmode As Long
    damages As Boolean
    target As Long
    x As Single
    y As Single
    screenx As Single
    screeny As Single
    centerx As Single
    centery As Single
    xspeed As Single
    yspeed As Single
    accel As Single
    damage As Single
    lifelength As Long
    spawnssmoke As Boolean
    spawnrate As Long
    tickcount As Long
    spawntick As Long
    usestick As Boolean
    'width height
    width As Long
    height As Long
    'enabled?
    benabled As Boolean
    'images
    species As Long
    radius As Single
    'pickup stuff
    'since projectiles are now pickups
    ispickup As Boolean
    
    credits As Long
    food As Long
    metals As Long
    weapons As Long
    gems As Long
    
End Type

Public Type statn
    sname As String
    x As Single
    y As Single
    screenx As Single
    screeny As Single
    centerx As Single
    centery As Single
    xspeed As Single
    yspeed As Single
    'prices
    foodprices As Long
    metalsprices As Long
    weaponsprices As Long
    gemsprices As Long
    'how many does the station have?
    food As Long
    metals As Long
    weapons As Long
    gems As Long
    'image etc
    species As Long
    'tick
    pricechangetick As Long
    'width height
    width As Long
    height As Long
    'enabled?
    benabled As Boolean
    radius As Single
End Type

Public Type engset
    colltick As Long
    phystick As Long
    rendertick As Long
    collacc As Long
    physacc As Long
    renderacc As Long
    statstick As Long
End Type

Public weapons(3) As weapn
    
Public player(30) As plr

Public projectile(250) As projectil

Public station(20) As statn

Public enginesettings As engset

Public numplayers As Long
Public numprojectiles As Long
Public numstations As Long


Public Sub game_init()
'display "loading" on screen while this stuff is done
main.Show
pbgl.glsetcolor main.picgame, vbWhite
pbgl.gltext main.picgame, main.picgame.width / 2 - 40, main.picgame.height / 2 - 20, "Loading..."
main.picgame.Refresh

camera.camheight = 480
camera.camwidth = 640

enginesettings.collacc = 1
enginesettings.physacc = 1
enginesettings.renderacc = 1
enginesettings.colltick = 0
enginesettings.phystick = 0
enginesettings.rendertick = 0
enginesettings.statstick = 0

'setting the numobjects values
numplayers = 30
numprojectiles = 250
numstations = 20

'this gets run at the start of the program, to set up various game parameters
pbgl.glloadpicture main.p1, App.Path & "\images\ship1.bmp"
pbgl.glloadpicture main.p2, App.Path & "\images\ship2.bmp"
pbgl.glloadpicture main.p3, App.Path & "\images\ship3.bmp"
pbgl.glloadpicture main.p4, App.Path & "\images\ship4.bmp"
pbgl.glloadpicture main.p5, App.Path & "\images\ship5.bmp"
pbgl.glloadpicture main.p6, App.Path & "\images\ship6.bmp"
pbgl.glloadpicture main.p7, App.Path & "\images\ship7.bmp"
pbgl.glloadpicture main.p8, App.Path & "\images\ship8.bmp"
pbgl.glloadpicture main.p9, App.Path & "\images\ship9.bmp"
pbgl.glloadpicture main.p10, App.Path & "\images\ship10.bmp"
pbgl.glloadpicture main.p11, App.Path & "\images\ship11.bmp"
pbgl.glloadpicture main.p12, App.Path & "\images\shipmask.bmp"
pbgl.glloadpicture main.p13, App.Path & "\images\pickup.bmp"
pbgl.glloadpicture main.p14, App.Path & "\images\pickupmask.bmp"
pbgl.glloadpicture main.p15, App.Path & "\images\station.bmp"
pbgl.glloadpicture main.p16, App.Path & "\images\stationmask.bmp"
pbgl.glloadpicture main.p17, App.Path & "\images\smoke.bmp"
pbgl.glloadpicture main.p18, App.Path & "\images\fire.bmp"
pbgl.glloadpicture main.p19, App.Path & "\images\smokefiremask.bmp"
pbgl.glloadpicture main.p20, App.Path & "\images\bullet.bmp"
pbgl.glloadpicture main.p21, App.Path & "\images\bulletmask.bmp"
pbgl.glloadpicture main.statbar, App.Path & "\images\statbar.jpg"
pbgl.glloadpicture main.statbarmask, App.Path & "\images\statbar mask.jpg"
pbgl.glloadpicture main.xpbar, App.Path & "\images\xpbar.jpg"
pbgl.glloadpicture main.xpbarmask, App.Path & "\images\xpbar mask.jpg"

'setting up weapons
weapons(0).name = "Simple Plasma"
weapons(0).accel = 0.2
weapons(0).damage = 40
weapons(0).edrain = 100
weapons(0).follows = True
weapons(0).followmode = 1
weapons(0).lifelength = 192
weapons(0).details = "Simple Homing Plasma. Low damage and energy useage. Slow moving, but it also burns out slow."

weapons(1).name = "Advanced Plasma"
weapons(1).accel = 0.3
weapons(1).damage = 75
weapons(1).edrain = 125
weapons(1).follows = True
weapons(1).followmode = 2
weapons(1).lifelength = 136
weapons(1).details = "Advanced Homing Plasma. Higher damage and energy usage. Moves fast, follows better, but also burns out quicker."

weapons(2).name = "Simple Rocket"
weapons(2).accel = 0.1
weapons(2).damage = 125
weapons(2).edrain = 50
weapons(2).follows = True
weapons(2).followmode = 1
weapons(2).spawnssmoke = True
weapons(2).spawnrate = 8
weapons(2).lifelength = 256
weapons(2).details = "Simple Rocket. Slow moving, low energy usage, bad followers. High damage and life length."

weapons(3).name = "Advanced Rockets"
weapons(3).accel = 0.4
weapons(3).damage = 100
weapons(3).edrain = 150
weapons(3).follows = True
weapons(3).followmode = 2
weapons(3).spawnssmoke = True
weapons(3).spawnrate = 4
weapons(3).lifelength = 208
weapons(3).details = "Advanced Rockets. Fast moving, good following. High energy usage and shorter life length."

'setting up stations and such

'load player save game info

'this just goes here for now to set up main player
'till i get the rest done
player(0).accel = 0.1
player(0).health = 100
player(0).maxhealth = 100
player(0).maxshields = 100
player(0).shields = 100
player(0).maxenergy = 250
player(0).energy = 250
player(0).x = 0
player(0).y = 0
player(0).benabled = 1
player(0).sname = "Player"
player(0).fuel = 500
player(0).maxfuel = 500
player(0).species = 1
player(0).width = 32
player(0).height = 32
player(0).team = 1
player(0).weapon = weapons(0)
player(0).egrate = 1
player(0).exp = 0
player(0).maxexp = 1000


'set up player/pickup/station etc. radiuses
Dim x
For x = 0 To 30
    'player
    player(i).radius = 16
Next x

For x = 0 To 20
    'station
    station(i).radius = 64
Next x


'make a bunch of players for test
For r = 0 To 9
spawn_player rand_num(-2048, 2048), rand_num(-2048, 2048), "Pirate", 2, 1, 1000, 1000, 5, 500, 500, 500, 0.1, 1, rand_num(2, 9), 5, 100, 5, 5, 5, 5
Next r

'For f = 0 To 66
'spawn_projectile rand_num(-256, 256), rand_num(-256, 256), 3, 8, 8, 0, 0, True, 20, 0, False, 0, 15000, True, False, 0, 4, 4
'Next f

'For k = 0 To 66
'spawn_player rand_num(-2048, 2048), rand_num(-2048, 2048), "Trader", 1, 1, 50, 50, 50, 50, 500, 500, 0.1, 1, 10, 5, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
'Next k

'For z = 0 To 66
'spawn_player rand_num(-2048, 2048), rand_num(-2048, 2048), "Police", 1, 1, 50, 50, 50, 50, 500, 500, 0.1, 1, 11, 5, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
'Next z

'For p = 0 To 99
'spawn_projectile rand_num(-2048, 2048), rand_num(-2048, 2048), 1, 16, 16, rand_num(-20, 20), rand_num(-20, 20), False, 1, 0.15, True, 4, 64, True, True, 1, 1, 8
'Next p

'For p = 0 To 99
'spawn_projectile rand_num(-2048, 2048), rand_num(-2048, 2048), 1, 16, 16, rand_num(-20, 20), rand_num(-20, 20), False, 0, 0.15, True, 4, 64, True, True, 1, 2, 8
'Next p

'For p = 0 To 99
'spawn_projectile rand_num(-2048, 2048), rand_num(-2048, 2048), 1, 16, 16, rand_num(-20, 20), rand_num(-20, 20), False, 0, 0.15, True, 4, 64, True, True, 1, 3, 8
'Next p

'For p = 0 To 99
'spawn_projectile rand_num(-2048, 2048), rand_num(-2048, 2048), 1, 16, 16, rand_num(-20, 20), rand_num(-20, 20), False, 0, 0.15, True, 4, 64, True, True, 1, 4, 4
'Next p

'For p = 0 To 66
'spawn_projectile rand_num(-2048, 2048), rand_num(-2048, 2048), 1, 16, 16, rand_num(-20, 20), rand_num(-20, 20), False, 0, 0.15, True, 4, 64, True, True, 1, 5, 1
'Next p

'For p = 0 To 99
'spawn_pickup rand_num(-2048, 2048), rand_num(-2048, 2048), rand_num(-20, 20), rand_num(-20, 20), 64, True, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
'Next p

'For s = 0 To 350
'spawn_station rand_num(-2048, 2048), rand_num(-2048, 2048), rand_num(-20, 20), rand_num(-20, 20), "Station", 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
'Next s

End Sub

Public Sub keyboard_actions()
'in here goes every keyboard related even
'ex: a to acquire target, space to shoot etc.
If keyboard.downdown = True Then
    move_player_down (0)
End If

If keyboard.updown = True Then
    move_player_up (0)
End If

If keyboard.rightdown = True Then
    move_player_right (0)
End If

If keyboard.leftdown = True Then
    move_player_left (0)
End If

If keyboard.spacedown = True And player(0).firepressed = False Then
    player(0).firepressed = True
    player_fire 0
End If

'comment these lines out when the game is released,
'or add something so they can be used to debug

If keyboard.adown = True Then
    maxframerate = maxframerate + 1
End If

If keyboard.zdown = True Then
    maxframerate = maxframerate - 1
End If

End Sub

Public Sub move_player_down(plr As Long)
If player(plr).fuel > 0 Then
    player(plr).fuel = player(plr).fuel - player(plr).accel
    player(plr).yspeed = player(plr).yspeed + player(plr).accel
End If
End Sub

Public Sub move_player_up(plr As Long)
If player(plr).fuel > 0 Then
    player(plr).fuel = player(plr).fuel - player(plr).accel
    player(plr).yspeed = player(plr).yspeed - player(plr).accel
End If
End Sub

Public Sub move_player_right(plr As Long)
If player(plr).fuel > 0 Then
    player(plr).fuel = player(plr).fuel - player(plr).accel
    player(plr).xspeed = player(plr).xspeed + player(plr).accel
End If
End Sub

Public Sub move_player_left(plr As Long)
If player(plr).fuel > 0 Then
    player(plr).fuel = player(plr).fuel - player(plr).accel
    player(plr).xspeed = player(plr).xspeed - player(plr).accel
End If
End Sub

Public Sub test_ai(plr As Long)
'this is the temporary test AI, all bots follow player

If player(plr).x < player(0).x Then
    move_player_right (plr)
End If

If player(plr).x > player(0).x Then
    move_player_left (plr)
End If

If player(plr).y < player(0).y Then
    move_player_down (plr)
End If

If player(plr).y > player(0).y Then
    move_player_up (plr)
End If

End Sub


Public Sub damage_player(plr As Long, damage As Single)
If player(plr).shields > 0 Then
    player(plr).shields = player(plr).shields - damage
ElseIf player(plr).shields <= 0 Then
    player(plr).health = player(plr).health - damage
End If
End Sub


Public Sub render_player_stats()
'render stat bars
pbgl.glsetcolor main.picgame, vbRed
pbgl.glfilledrectangle main.picgame, 14, 12, (player(0).health / player(0).maxhealth) * 171, 15
pbgl.glsetcolor main.picgame, vbYellow
pbgl.glfilledrectangle main.picgame, 14, 40, (player(0).shields / player(0).maxshields) * 171, 15
pbgl.glsetcolor main.picgame, vbGreen
pbgl.glfilledrectangle main.picgame, 14, 66, (player(0).energy / player(0).maxenergy) * 171, 15
pbgl.glsetcolor main.picgame, vbMagenta
pbgl.glfilledrectangle main.picgame, 14, 92, (player(0).fuel / player(0).maxfuel) * 171, 15



pbgl.gltransdraw main.picgame, main.xpbar, main.xpbarmask, 0, 460, 120, 20, 0, 0

pbgl.glsetcolor main.picgame, vbWhite
pbgl.glfilledrectangle main.picgame, 5, 466, (player(0).exp / player(0).maxexp) * 108, 7

pbgl.gltransdraw main.picgame, main.statbar, main.statbarmask, 0, 0, 200, 120, 0, 0

'render number stats
'pbgl.glsetcolor main.picgame, vbBlue
'pbgl.gltext main.picgame, 1, 1, "Health = " & player(0).health & "/" & player(0).maxhealth
'pbgl.glsetcolor main.picgame, vbGreen
'pbgl.gltext main.picgame, 1, 20, "Shields = " & player(0).shields & "/" & player(0).maxshields
'pbgl.glsetcolor main.picgame, vbYellow
'pbgl.gltext main.picgame, 1, 40, "Energy = " & player(0).energy & "/" & player(0).maxenergy
'pbgl.glsetcolor main.picgame, vbMagenta
'pbgl.gltext main.picgame, 1, 60, "Fuel = " & player(0).fuel & "/" & player(0).maxfuel

End Sub


Public Sub player_get_pickup(plr As Long, pkp As Long)
player(plr).credits = player(plr).credits + projectile(pkp).credits
player(plr).food = player(plr).food + projectile(pkp).food
player(plr).metals = player(plr).metals + projectile(pkp).metals
player(plr).weapons = player(plr).weapons + projectile(pkp).weapons
player(plr).gems = player(plr).gems + projectile(pkp).gems
End Sub

Public Sub check_for_collisions()

Dim i As Long  'Long is faster than Integer (its the same size as the CPU uses)
Dim r As Long

Dim px As Single, py As Single, pr As Single

    For i = 0 To numplayers
        With player(i)   'until the "end with", anything starting with . is treated as if it starts with player(i).
          px = .centerx
          py = .centery
          pr = .radius
        End With
        
        For r = 0 To numprojectiles
            'check player/projectiles
          With projectile(r)
          If projectile(r).benabled And player(i).benabled Then
            If ((pr + .radius) * (pr + .radius)) >= ((.centerx - px) * (.centerx - px)) + ((.centery - py) * (.centery - py)) Then
                collision_player_projectile i, r
            End If
          End If
          End With
        Next r
    Next i

'my old slow code
'check for collissions between player/projectile and player/pickup
'    Dim i As Long
'    Dim r As Long
'
'    For i = 0 To numplayers
'        If player(i).benabled Then
'            For r = 0 To numprojectiles
'                'check player/projectiles
'                If projectile(r).benabled Then
'                        If ((player(i).radius + projectile(r).radius) * (player(i).radius + projectile(r).radius)) >= ((projectile(r).centerx - player(i).centerx) * (projectile(r).centerx - player(i).centerx)) + ((projectile(r).centery - player(i).centery) * (projectile(r).centery - player(i).centery)) Then
'                            collision_player_projectile i, r
'                        End If
'                End If
'            Next r
'        End If
'      Next i
End Sub



Public Sub dmg_smoke()
For i = 0 To numplayers
    If player(i).health <= 150 And player(i).health > 0 Then
        spawn_projectile player(i).centerx + rand_num(-8, 8), player(i).centery + rand_num(-8, 8), 0, 8, 8, 0, 0, False, 0, 0, False, 0, 64, True, False, 0, 2, 4
    End If
Next i
End Sub


Public Sub collision_player_projectile(plr As Long, proj As Long)
'as far as this goes,
'as long as a projectile never damages
'and is a pickup at the same time
'no problems should occur
If projectile(proj).benabled Then
If projectile(proj).damages Then
    If projectile(proj).team <> player(plr).team Then
        damage_player plr, projectile(proj).damage
        disable_projectile proj
    End If
End If

If projectile(proj).ispickup Then
    'pickup the projectiles stuff
    disable_projectile proj
End If
End If
End Sub

'#####################
'GAAAAHHHH
'Another problem,
'As usual.
'#####################

Public Sub disable_projectile(proj As Long)
projectile(proj).tickcount = 0
'projectile(proj) = projectile(numprojectiles)
'numprojectiles = numprojectiles - 1
projectile(proj).benabled = False
End Sub

Public Sub handle_player_ticks()
Dim i As Long
    'For i = 0 To numplayers
    '    If benabled Then
    '        If player(i).acquiretick > 0 Then
    '            player(i).acquiretick = player(i).acquiretick + 1
    '        End If
    '        If player(i).acquiretick >= 32 Then
    '            player(i).acquiretick = 0
    '        End If
    '    End If
    'Next i
    For i = 0 To numplayers
        If player(i).energy < player(i).maxenergy Then
            player(i).energy = player(i).energy + player(i).egrate
        End If
    Next i
End Sub

Public Sub handle_projectile_ticks()
Dim i As Long
    For i = 0 To numprojectiles
        With projectile(i)
        If .benabled Then
            If .usestick Then
                .spawntick = .spawntick + 1
                .tickcount = .tickcount + 1
                    If .spawntick = .spawnrate Then
                        .spawntick = 0
                        'spawn whatever it spawns
                    End If
                    If .tickcount = .lifelength Then
                        .tickcount = 0
                        'this disables the current projectile
                        'and clears him from the array
                        
                        'projectile(i) = projectile(numprojectiles)
                        'numprojectiles = numprojectiles - 1
                        projectile(i).benabled = False
                    End If
            End If
        End If
        End With
    Next i
End Sub

Public Sub handle_stars()
'Dim xk As Long
'xk = xk + 1
'If xk = 16 Then
'xk = 0
    Dim zzor As Long
    For zzor = 0 To 4
        spawn_projectile rand_num(player(0).x - 1000, player(0).x + 1000), rand_num(player(0).y - 1000, player(0).y + 1000), 0, 1, 1, 0, 0, False, 0, 0, 0, 0, 32, True, False, 1, 5, 1
    Next zzor
'End If
End Sub

Public Sub acquire_target(plr As Long)

Dim shortest As Single
Dim shortplr As Long
Dim px As Single
Dim py As Single
Dim pr As Single
Dim dist As Single

If player(plr).acquiretick = 0 Then
    player(plr).acquiretick = 1
Else
    Exit Sub
End If

shortest = 1000

With player(plr)
px = player(plr).centerx
py = player(plr).centery
pr = player(plr).radius
End With

For i = 0 To numplayers
    If player(i).benabled = True Then
        If player(i).team <> player(plr).team Then
            With player(i)
                If i <> plr Then
                    dist = Sqr(((player(plr).centerx - player(i).centerx) * (player(plr).centerx - player(i).centerx)) + ((player(plr).centery - player(i).centery) * (player(plr).centery - player(i).centery)))
                End If
            End With
            
            If dist < shortest Then
                shortest = dist
                player(plr).target = i
            End If
        End If
        End If
Next i


End Sub

Public Sub player_fire(plr As Long)
    If player(plr).energy >= player(plr).weapon.edrain Then
        player(plr).energy = player(plr).energy - player(plr).weapon.edrain
        spawn_projectile player(plr).centerx, player(plr).centery, player(plr).team, 4, 4, rand_num(-20, 20), rand_num(-20, 20), True, player(plr).weapon.damage, player(plr).weapon.accel, player(plr).weapon.spawnssmoke, player(plr).weapon.spawnrate, player(plr).weapon.lifelength, True, player(plr).weapon.follows, player(plr).weapon.followmode, 4, 4
    End If
End Sub



'#########################################################
'all subs below this
'are for spawning
'various game objects
'#########################################################
    
Public Sub spawn_player(xpos As Single, ypos As Single, namme As String, team As Integer, wpn As Integer, maxhealth As Single, maxshield As Single, egrate As Single, maxenergy As Single, fuel As Single, maxfuel As Single, accelerationrate As Single, followmode As Integer, species As Integer, bays As Integer, credits As Integer, food As Integer, metals As Integer, weaponss As Integer, gems As Integer)
'for spawning players!
Dim i As Long
For i = 0 To numplayers
    If player(i).benabled = False Then
        player(i).team = team
        player(i).x = xpos
        player(i).y = ypos
        player(i).sname = namme
        player(i).weapon = weapons(wpn)
        player(i).maxhealth = maxhealth
        player(i).health = maxhealth
        player(i).maxshields = maxshields
        player(i).shields = maxshields
        player(i).maxenergy = maxenergy
        player(i).egrate = egrate
        player(i).bays = bays
        player(i).followmode = followmode
        'yes, this player is now enabled
        player(i).benabled = True
        '^^
        player(i).accel = accelerationrate
        player(i).species = species
        player(i).height = 32
        player(i).width = 32
        player(i).egrate = egrate
        
        player(i).fuel = fuel
        player(i).maxfuel = maxfuel
        player(i).radius = 16
        'setting what the player carries
        player(i).credits = credits
        player(i).food = food
        player(i).metals = metals
        player(i).weapons = weaponss
        player(i).gems = gems
        'numplayers = numplayers + 1
        Exit Sub
    End If
Next i
End Sub

Public Sub spawn_projectile(xpos As Single, ypos As Single, team As Long, width As Long, height As Long, xspeed As Long, yspeed As Long, damages As Boolean, damage As Long, accel As Single, spawnssmoke As Boolean, spawnrate As Long, lifelength As Long, usestick As Boolean, follows As Boolean, followmode As Long, species As Long, radius As Single)
'for spawning projectiles!
Dim i As Long
For i = 0 To numprojectiles
    If projectile(i).benabled = False Then
        projectile(i).team = team
        projectile(i).x = xpos
        projectile(i).y = ypos
        projectile(i).accel = accel
        projectile(i).followmode = followmode
        projectile(i).follows = follows
        projectile(i).spawnssmoke = spawnssmoke
        projectile(i).lifelength = lifelength
        projectile(i).spawnrate = spawnrate
        projectile(i).damages = damages
        projectile(i).damage = damage
        projectile(i).xspeed = xspeed
        projectile(i).yspeed = yspeed
        'yes, this projectile is now enabled
        projectile(i).benabled = True
        '^^
        projectile(i).accel = accelerationrate
        projectile(i).species = species
        projectile(i).height = height
        projectile(i).width = width
        projectile(i).radius = radius
        projectile(i).usestick = usestick
        projectile(i).ispickup = False
        'numprojectiles = numprojectiles + 1
        Exit Sub
    End If
Next i
Exit Sub
End Sub

Public Sub spawn_pickup(xpos As Single, ypos As Single, xspeed As Long, yspeed As Long, lifelength As Long, usestick As Boolean, credits As Long, food As Integer, metals As Integer, weaponss As Integer, gems As Integer)
'even tho projectiles/pickups are now combined
'i still have this here so i dont have to mess with a bunch of
'meaningless values if im only spawning a bullet
'but if im spawning a pickup i need it
'so here it is
Dim i As Long
For i = 0 To numprojectiles
    If projectile(i).benabled = False Then
        projectile(i).ispickup = True
        projectile(i).lifelength = lifelength
        projectile(i).usestick = usestick
        projectile(i).x = xpos
        projectile(i).y = ypos
        projectile(i).xspeed = xspeed
        projectile(i).yspeed = yspeed
        'yes, this pickup is now enabled
        projectile(i).benabled = True
        '^^
        projectile(i).height = 16
        projectile(i).width = 16
        projectile(i).credits = credits
        projectile(i).food = food
        projectile(i).metals = metals
        projectile(i).weapons = weaponss
        projectile(i).gems = gems
        projectile(i).species = 1
        'numprojectiles = numprojectiles + 1
        Exit Sub
    End If
Next i
End Sub


Public Sub spawn_station(xpos As Single, ypos As Single, xspeed As Single, yspeed As Single, namme As String, food As Integer, metals As Integer, weaponss As Integer, gems As Integer, foodprice As Integer, metalsprice As Integer, weaponspricee As Integer, gemsprice As Integer)
Dim i As Long
For i = 0 To numstations
    If station(i).benabled = False Then
        station(i).x = xpos
        station(i).y = ypos
        station(i).xspeed = xspeed
        station(i).yspeed = yspeed
        'yes, this pickup is now enabled
        station(i).benabled = True
        '^^
        station(i).height = 128
        station(i).width = 128
        station(i).weapons = weaponss
        station(i).food = food
        station(i).metals = metals
        station(i).gems = gems
        station(i).weaponsprices = weaponspricee
        station(i).foodprices = foodprice
        station(i).metalsprices = metalsprice
        station(i).gemsprices = gemsprice
        station(i).sname = namme
        'numstations = numstations + 1
        Exit Sub
    End If
Next i
End Sub


