Attribute VB_Name = "graphics"
'pbgl declaration
Public pbgl As New clspbgl

Public Type cam
    x As Single
    y As Single
    camwidth As Single
    camheight As Single
End Type

Public camera As cam

Public fpsstatus As String

Public maxframerate As Integer

Public framerate As Integer

Public Sub render_eng_stats()

'adjust framerate to 32
'every second it gets adjusted
'so it doesnt go all homo and stuff
enginesettings.statstick = enginesettings.statstick + 1
If enginesettings.statstick >= 8 Then
enginesettings.statstick = 0
    If framerate > 32 Then
        maxframerate = maxframerate - 1
    End If

    If framerate < 32 And maxframerate < 80 Then
        maxframerate = maxframerate + 1
    End If
End If


pbgl.glsetcolor main.picgame, vbWhite
'render fps
pbgl.gltext main.picgame, 615, 460, Str(framerate)
'render x/y pos
pbgl.gltext main.picgame, 1, main.picgame.height - 24, "X = " & player(0).x & " Y = " & player(0).y & " Camera X = " & camera.x & " Camera Y = " & camera.y
End Sub


Public Sub render_all()
Dim i As Integer

'rendering all the players, projectiles, stations, and pickups
For i = 0 To 999


'render projectiles
If projectile(i).benabled = True Then
If projectile(i).x > camera.x And projectile(i).x < (camera.x + camera.camwidth) And projectile(i).y > camera.y And projectile(i).y < (camera.y + camera.camheight) Then
    projectile(i).screenx = projectile(i).x - camera.x
    projectile(i).screeny = projectile(i).y - camera.y
    
    'identify species and render
    If projectile(i).species = 0 Then
        Exit Sub
    ElseIf projectile(i).species = 1 Then
        pbgl.gltransdraw main.picgame, main.p13, main.p14, projectile(i).screenx, projectile(i).screeny, 16, 16, 0, 0
    ElseIf projectile(i).species = 2 Then
        pbgl.gltransdraw main.picgame, main.p17, main.p19, projectile(i).screenx, projectile(i).screeny, 16, 16, 0, 0
    ElseIf projectile(i).species = 3 Then
        pbgl.gltransdraw main.picgame, main.p18, main.p19, projectile(i).screenx, projectile(i).screeny, 8, 8, 0, 0
    ElseIf projectile(i).species = 4 Then
        pbgl.gltransdraw main.picgame, main.p20, main.p21, projectile(i).screenx, projectile(i).screeny, 8, 8, 0, 0
    ElseIf projectile(i).species = 5 Then
        pbgl.glsetcolor main.picgame, vbWhite
        pbgl.glsetpixel main.picgame, projectile(i).screenx, projectile(i).screeny
    End If
End If
End If


'render stations
If station(i).benabled = True Then
If station(i).x > camera.x And station(i).x < (camera.x + camera.camwidth) And station(i).y > camera.y And station(i).y < (camera.y + camera.camheight) Then
    station(i).screenx = station(i).x - camera.x
    station(i).screeny = station(i).y - camera.y
    
    
    pbgl.glsetcolor main.picgame, vbWhite
    pbgl.gltext main.picgame, station(i).screenx, station(i).screeny - 24, station(i).sname
    pbgl.gltransdraw main.picgame, main.p15, main.p16, station(i).screenx, station(i).screeny, 128, 128, 0, 0
    
End If
End If


'render players
If player(i).benabled = True Then
If player(i).x > camera.x And player(i).x < (camera.x + camera.camwidth) And player(i).y > camera.y And player(i).y < (camera.y + camera.camheight) Then
    player(i).screenx = player(i).x - camera.x
    player(i).screeny = player(i).y - camera.y
    
    'identify species and render
    If player(i).species = 0 Then
        Exit Sub
    ElseIf player(i).species = 1 Then
        pbgl.glsetcolor main.picgame, vbWhite
        pbgl.gltext main.picgame, player(i).screenx, player(i).screeny - 24, player(i).sname
        pbgl.gltransdraw main.picgame, main.p1, main.p12, player(i).screenx, player(i).screeny, 32, 32, 0, 0
    ElseIf player(i).species = 2 Then
        pbgl.glsetcolor main.picgame, vbRed
        pbgl.gltext main.picgame, player(i).screenx, player(i).screeny - 24, player(i).sname
        pbgl.gltransdraw main.picgame, main.p2, main.p12, player(i).screenx, player(i).screeny, 32, 32, 0, 0
    ElseIf player(i).species = 3 Then
        pbgl.glsetcolor main.picgame, vbRed
        pbgl.gltext main.picgame, player(i).screenx, player(i).screeny - 24, player(i).sname
        pbgl.gltransdraw main.picgame, main.p3, main.p12, player(i).screenx, player(i).screeny, 32, 32, 0, 0
    ElseIf player(i).species = 4 Then
        pbgl.glsetcolor main.picgame, vbRed
        pbgl.gltext main.picgame, player(i).screenx, player(i).screeny - 24, player(i).sname
        pbgl.gltransdraw main.picgame, main.p4, main.p12, player(i).screenx, player(i).screeny, 32, 32, 0, 0
    ElseIf player(i).species = 5 Then
        pbgl.glsetcolor main.picgame, vbRed
        pbgl.gltext main.picgame, player(i).screenx, player(i).screeny - 24, player(i).sname
        pbgl.gltransdraw main.picgame, main.p5, main.p12, player(i).screenx, player(i).screeny, 32, 32, 0, 0
    ElseIf player(i).species = 6 Then
        pbgl.glsetcolor main.picgame, vbRed
        pbgl.gltext main.picgame, player(i).screenx, player(i).screeny - 24, player(i).sname
        pbgl.gltransdraw main.picgame, main.p6, main.p12, player(i).screenx, player(i).screeny, 32, 32, 0, 0
    ElseIf player(i).species = 7 Then
        pbgl.glsetcolor main.picgame, vbRed
        pbgl.gltext main.picgame, player(i).screenx, player(i).screeny - 24, player(i).sname
        pbgl.gltransdraw main.picgame, main.p7, main.p12, player(i).screenx, player(i).screeny, 32, 32, 0, 0
    ElseIf player(i).species = 8 Then
        pbgl.glsetcolor main.picgame, vbRed
        pbgl.gltext main.picgame, player(i).screenx, player(i).screeny - 24, player(i).sname
        pbgl.gltransdraw main.picgame, main.p8, main.p12, player(i).screenx, player(i).screeny, 32, 32, 0, 0
    ElseIf player(i).species = 9 Then
        pbgl.glsetcolor main.picgame, vbRed
        pbgl.gltext main.picgame, player(i).screenx, player(i).screeny - 24, player(i).sname
        pbgl.gltransdraw main.picgame, main.p9, main.p12, player(i).screenx, player(i).screeny, 32, 32, 0, 0
    ElseIf player(i).species = 10 Then
        pbgl.glsetcolor main.picgame, vbGreen
        pbgl.gltext main.picgame, player(i).screenx, player(i).screeny - 24, player(i).sname
        pbgl.gltransdraw main.picgame, main.p10, main.p12, player(i).screenx, player(i).screeny, 32, 32, 0, 0
    ElseIf player(i).species = 11 Then
        pbgl.glsetcolor main.picgame, vbBlue
        pbgl.gltext main.picgame, player(i).screenx, player(i).screeny - 24, player(i).sname
        pbgl.gltransdraw main.picgame, main.p11, main.p12, player(i).screenx, player(i).screeny, 32, 32, 0, 0
    End If
End If
End If

Next i

End Sub

Public Sub update_camera()
camera.x = player(0).x - 320
camera.y = player(0).y - 240
End Sub
